package com.iotechn.unimall.admin.api.cloud;


import com.iotechn.unimall.data.domain.AboutUsInfo;
import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.model.Page;
import java.util.Date;

/**
 * 记录关于我们信息Service接口
 * 
 * @author jlb
 * @date 2023-05-31
 */
@HttpOpenApi(group = "admin.cloud.aboutUsInfo", description = "记录关于我们信息")
public interface IAboutUsInfoService{
	@HttpMethod(description = "新增",   permissionName = "记录关于我们信息管理")
	public Boolean add(@NotNull @HttpParam(name = "aboutUsInfo", type = HttpParamType.COMMON, description = "记录关于我们信息") AboutUsInfo aboutUsInfo)throws ServiceException;

	@HttpMethod(description = "列表", permissionName = "记录关于我们信息管理")
	public Page<AboutUsInfo> list(
								@HttpParam(name = "title", type = HttpParamType.COMMON, description = "标题") String title,
							@HttpParam(name = "deputyTitle", type = HttpParamType.COMMON, description = "副标题") String deputyTitle,
							@HttpParam(name = "coverImage", type = HttpParamType.COMMON, description = "封面图片") String coverImage,
							@HttpParam(name = "videoUrl", type = HttpParamType.COMMON, description = "视频地址") String videoUrl,
							@HttpParam(name = "classify", type = HttpParamType.COMMON, description = "分类") String classify,
							@HttpParam(name = "content", type = HttpParamType.COMMON, description = "内容") String content,
							@HttpParam(name = "details", type = HttpParamType.COMMON, description = "详情") String details,
							@HttpParam(name = "language", type = HttpParamType.COMMON, description = "语言") String language,
							@HttpParam(name = "status", type = HttpParamType.COMMON, description = "状态") String status,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
					@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
		@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)
		throws ServiceException;

	@HttpMethod(description = "删除",permissionName = "记录关于我们信息管理")
	public Boolean delete(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")String id)throws ServiceException;

	@HttpMethod(description = "修改",  permissionName = "记录关于我们信息管理")
	public Boolean update(@NotNull @HttpParam(name = "aboutUsInfo", type = HttpParamType.COMMON, description = "记录关于我们信息") AboutUsInfo aboutUsInfo)throws ServiceException;

	@HttpMethod(description = "查询", permissionName = "记录关于我们信息管理")
	public AboutUsInfo get(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")Long id)throws ServiceException;
	
	@HttpMethod(description = "导出excl表",  permissionName = "记录关于我们信息管理")
	public String export(
								@HttpParam(name = "title", type = HttpParamType.COMMON, description = "标题") String title,
							@HttpParam(name = "deputyTitle", type = HttpParamType.COMMON, description = "副标题") String deputyTitle,
							@HttpParam(name = "coverImage", type = HttpParamType.COMMON, description = "封面图片") String coverImage,
							@HttpParam(name = "videoUrl", type = HttpParamType.COMMON, description = "视频地址") String videoUrl,
							@HttpParam(name = "classify", type = HttpParamType.COMMON, description = "分类") String classify,
							@HttpParam(name = "content", type = HttpParamType.COMMON, description = "内容") String content,
							@HttpParam(name = "details", type = HttpParamType.COMMON, description = "详情") String details,
							@HttpParam(name = "language", type = HttpParamType.COMMON, description = "语言") String language,
							@HttpParam(name = "status", type = HttpParamType.COMMON, description = "状态") String status,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
				@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
	@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)throws ServiceException;
	
}
