package com.iotechn.unimall.admin.api.cloud;


import com.iotechn.unimall.data.domain.ImageManagement;
import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.model.Page;
import java.util.Date;

/**
 * 图片管理信息Service接口
 * 
 * @author jlb
 * @date 2023-05-30
 */
@HttpOpenApi(group = "admin.cloud.imageManagement", description = "图片管理信息")
public interface IImageManagementService{
	@HttpMethod(description = "新增",   permissionName = "图片管理信息管理")
	public Boolean add(@NotNull @HttpParam(name = "imageManagement", type = HttpParamType.COMMON, description = "图片管理信息") ImageManagement imageManagement)throws ServiceException;

	@HttpMethod(description = "列表", permissionName = "图片管理信息管理")
	public Page<ImageManagement> list(
								@HttpParam(name = "imageUrl", type = HttpParamType.COMMON, description = "图片地址") String imageUrl,
							@HttpParam(name = "imageTitle", type = HttpParamType.COMMON, description = "图片标题") String imageTitle,
							@HttpParam(name = "language", type = HttpParamType.COMMON, description = "语言") String language,
								@HttpParam(name = "classify", type = HttpParamType.COMMON, description = "分类") String classify,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
					@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
		@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)
		throws ServiceException;

	@HttpMethod(description = "删除",permissionName = "图片管理信息管理")
	public Boolean delete(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")String id)throws ServiceException;

	@HttpMethod(description = "修改",  permissionName = "图片管理信息管理")
	public Boolean update(@NotNull @HttpParam(name = "imageManagement", type = HttpParamType.COMMON, description = "图片管理信息") ImageManagement imageManagement)throws ServiceException;

	@HttpMethod(description = "查询", permissionName = "图片管理信息管理")
	public ImageManagement get(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")Long id)throws ServiceException;
	
	@HttpMethod(description = "导出excl表",  permissionName = "图片管理信息管理")
	public String export(
								@HttpParam(name = "imageUrl", type = HttpParamType.COMMON, description = "图片地址") String imageUrl,
							@HttpParam(name = "imageTitle", type = HttpParamType.COMMON, description = "图片标题") String imageTitle,
							@HttpParam(name = "language", type = HttpParamType.COMMON, description = "语言") String language,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
				@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
	@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)throws ServiceException;
	
}
