package com.iotechn.unimall.admin.api.cloud;


import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.domain.ProductManagement;
import com.iotechn.unimall.data.model.Page;
import java.util.Date;

/**
 * 产品管理信息Service接口
 * 
 * @author jlb
 * @date 2023-05-26
 */
@HttpOpenApi(group = "admin.unimall.productManagement", description = "产品管理信息")
public interface IProductManagementService{
	@HttpMethod(description = "新增", permissionName = "产品管理信息管理")
	public Boolean add(@NotNull @HttpParam(name = "productManagement", type = HttpParamType.COMMON, description = "产品管理信息") ProductManagement productManagement)throws ServiceException;

	@HttpMethod(description = "列表",  permissionName = "产品管理信息管理")
	public Page<ProductManagement> list(
								@HttpParam(name = "productTitle", type = HttpParamType.COMMON, description = "产品标题") String productTitle,
							@HttpParam(name = "productIntroduction", type = HttpParamType.COMMON, description = "产品简介") String productIntroduction,
							@HttpParam(name = "coverImage", type = HttpParamType.COMMON, description = "封面") String coverImage,
							@HttpParam(name = "classification", type = HttpParamType.COMMON, description = "分类") String classification,
							@HttpParam(name = "productTemplate", type = HttpParamType.COMMON, description = "产品模板") String productTemplate,
							@HttpParam(name = "searchKeywords", type = HttpParamType.COMMON, description = " 搜索关键字") String searchKeywords,
							@HttpParam(name = "language", type = HttpParamType.COMMON, description = " 语言") String language,
							@HttpParam(name = "status", type = HttpParamType.COMMON, description = "状态") String status,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
					@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
		@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)
		throws ServiceException;

	@HttpMethod(description = "删除",permissionName = "产品管理信息管理")
	public Boolean delete(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")String id)throws ServiceException;

	@HttpMethod(description = "修改",  permissionName = "产品管理信息管理")
	public Boolean update(@NotNull @HttpParam(name = "productManagement", type = HttpParamType.COMMON, description = "产品管理信息") ProductManagement productManagement)throws ServiceException;

	@HttpMethod(description = "查询",permissionName = "产品管理信息管理")
	public ProductManagement get(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "")Long id)throws ServiceException;
	
	@HttpMethod(description = "导出excl表",  permissionName = "产品管理信息管理")
	public String export(
								@HttpParam(name = "productTitle", type = HttpParamType.COMMON, description = "产品标题") String productTitle,
							@HttpParam(name = "productIntroduction", type = HttpParamType.COMMON, description = "产品简介") String productIntroduction,
							@HttpParam(name = "coverImage", type = HttpParamType.COMMON, description = "封面") String coverImage,
							@HttpParam(name = "classification", type = HttpParamType.COMMON, description = "分类") String classification,
							@HttpParam(name = "productTemplate", type = HttpParamType.COMMON, description = "产品模板") String productTemplate,
							@HttpParam(name = "status", type = HttpParamType.COMMON, description = "状态") String status,
							@HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
							@HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
							@HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
				@HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
	@HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)throws ServiceException;
	
}
