package com.iotechn.unimall.data.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel.ColumnType;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.enums.FieldFill;
import com.iotechn.unimall.core.util.StringUtils;
import java.util.Date;

/**
 * 产品管理信息对象 product_management
 * 
 * @author jlb
 * @date 2023-05-26
 */
@Data
@TableName("product_management")
public class ProductManagement extends SuperDO{
    private static final long serialVersionUID = 1L;

    /**  */
    @TableId("id")
    private Long id;

    /** 产品标题 */
    @Excel(name = "产品标题")
    @TableField("product_title")
    private String productTitle;

    /** 产品简介 */
    @Excel(name = "产品简介")
    @TableField("product_introduction")
    private String productIntroduction;

    /** 封面 */
    @Excel(name = "封面")
    @TableField("cover_image")
    private String coverImage;

    /** 分类 */
    @Excel(name = "分类")
    @TableField("classification")
    private String classification;

    /** 产品模板 */
    @Excel(name = "产品模板")
    @TableField("product_template")
    private String productTemplate;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @TableField("product_describe")
    private String productDescribe;

    /** 搜索关键字 */
    @Excel(name = "搜索关键字")
    @TableField("search_keywords")
    private String searchKeywords;

    /** 语言 */
    @Excel(name = "语言")
    @TableField("language")
    private String language;

    /** 内容 */
    @Excel(name = "内容")
    @TableField("content")
    private String content;

    /** 状态 */
    @Excel(name = "状态")
    @TableField("status")
    private String status;

    /**  */
    @Excel(name = "", width = 30, dateFormat = "yyyy-MM-dd")
    @TableField("gmt_create")
    private Date gmtCreate;

    /**  */
    @Excel(name = "", width = 30, dateFormat = "yyyy-MM-dd")
    @TableField("gmt_update")
    private Date gmtUpdate;

    /** 删除标识 */
    @Excel(name = "删除标识")
    @TableField("delete_flag")
    private Long deleteFlag;


    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("productTitle", getProductTitle())
            .append("productIntroduction", getProductIntroduction())
            .append("coverImage", getCoverImage())
            .append("classification", getClassification())
            .append("productTemplate", getProductTemplate())
            .append("status", getStatus())
            .append("gmtCreate", getGmtCreate())
            .append("gmtUpdate", getGmtUpdate())
            .append("deleteFlag", getDeleteFlag())
            .toString();
    }
}
